"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNormalFragment = exports.generateConnectionFragment = void 0;
const _store_1 = require("../store");
function generateConnectionFragment(typeName, fragment) {
    const foundType = _store_1.SchemaStore.findType(typeName);
    if (foundType) {
        let outputFragment = '';
        const containsNode = !!foundType.fields.find((field) => field.name === 'node');
        const generateLines = (field, level) => {
            var _a;
            outputFragment += `${field.name} `;
            const { typeName, isScalar } = _store_1.SchemaStore.getFieldProps(field);
            if (!isScalar) {
                if (field.name === 'node') {
                    outputFragment += `{${fragment}} `;
                }
                else if (level < 4) {
                    outputFragment += `{ `;
                    const type = _store_1.SchemaStore.findType(typeName);
                    (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach((f) => generateLines(f, level + 1));
                    outputFragment += `} `;
                }
            }
        };
        foundType.fields.map((m) => generateLines(m, 0));
        return outputFragment;
    }
    return null;
}
exports.generateConnectionFragment = generateConnectionFragment;
function generateNormalFragment(type, connection) {
    let outputFragment = '';
    const THRESHOLD = connection ? 4 : 2;
    const createFragmentWithDeps = (field, level) => {
        var _a, _b;
        try {
            let { typeName, isScalar, isEnum } = _store_1.SchemaStore.getFieldProps(field);
            if (!isScalar && !isEnum) {
                const type = _store_1.SchemaStore.findType(typeName);
                if (level < THRESHOLD) {
                    const allChildrenFragmentable = type === null || type === void 0 ? void 0 : type.fields.some((s) => {
                        if (level + 1 >= THRESHOLD) {
                            const { isEnum, isScalar } = _store_1.SchemaStore.getFieldProps(s);
                            return isEnum || isScalar;
                        }
                        else {
                            return true;
                        }
                    });
                    if (allChildrenFragmentable) {
                        outputFragment += `${field.name} {`;
                        (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach((field) => createFragmentWithDeps(field, level + 1));
                        outputFragment += `} `;
                    }
                }
                else if ((type === null || type === void 0 ? void 0 : type.fields) && type.fields.length < 7) {
                    const allChildrenFragmentable = type === null || type === void 0 ? void 0 : type.fields.some((s) => {
                        if (level + 1 >= THRESHOLD) {
                            const { isEnum, isScalar } = _store_1.SchemaStore.getFieldProps(s);
                            return isEnum || isScalar;
                        }
                        else {
                            return true;
                        }
                    });
                    if (allChildrenFragmentable) {
                        outputFragment += `${field.name} {`;
                        (_b = type === null || type === void 0 ? void 0 : type.fields) === null || _b === void 0 ? void 0 : _b.forEach((field) => createFragmentNoDeps(field));
                        outputFragment += `} `;
                    }
                }
            }
            else {
                outputFragment += `${field.name} `;
            }
        }
        catch (e) {
            new Error(e);
        }
    };
    const createFragmentNoDeps = (field) => {
        let { isScalar, isEnum } = _store_1.SchemaStore.getFieldProps(field);
        if (isScalar || isEnum) {
            outputFragment += `${field.name} `;
        }
    };
    type.fields.map((m) => createFragmentWithDeps(m, 0));
    return outputFragment;
}
exports.generateNormalFragment = generateNormalFragment;
